searchNodes=[{"doc":"Telemetría is the opinionated wrapper for :telemetry providing handy macros to attach telemetry events to any function, private function, anonymous functions (on per-clause basis) and just random set of expressions.Telemetría exports three macros:deft/2 which is wrapping Kernel.def/2defpt/2 which is wrapping Kernel.defp/2t/2 which is wrapping the expression passed as the first parameter and adds the options passed as a keyword to the second parameter to the context of the respective telemetry eventTelemetría allows compile-time telemetry events definition and provides a compiler that is responsible for incremental builds and updates of the list of events telemetry is aware about.AdvantagesTelemetría takes care about managing events in the target application, makes it a single-letter change to turn a function into a function wrapped with telemetry call, measuring the execution time out of the box.It also allows to easily convert expressions to be be telemetry-aware.Besides that, telemetry: false flag allows to purge the calls in compile-time resulting in zero overhead (useful for benchmark, or like.)ExampleYou need to include the compiler in mix.exs:defmodule MyApp.MixProject do def project do [ # ... compilers: [:telemetria | Mix.compilers()], # ... ] end # ... endIn the modules you want to add telemetry to, you should require Telemetria (or, preferably, import Telemetria to make it available without FQN.) Once imported, the macros are available and tracked by the compiler.defmodule MyMod do import Telemetria defpt pi, do: 3.14 deft answer, do: 42 - pi() def inner do short_result = t(42 * 42) result = t do # long calculations :ok end end endUse in releases:telemetria compiler keeps track of the events in the compiler manifest file to support incremental builds. Also it spits out config/.telemetria.config.json config for convenience. It might be used in in the release configuration as shown below.releases: [ configured: [ # ..., config_providers: [{Telemetria.ConfigProvider, &quot;/etc/telemetria.json&quot;}] ] ]Options:otp_app - OTP application this telemetry is attached to. The default value is :telemetria.:enabled - Specifies whether telemetry should be enabled. The default value is true.:smart_log - Log format to use; when true, custom json would be used The default value is false.:applications - List the applications to enable Telemetria support for, with parameters The default value is [].:json_config_path - Relative path to JSON config The default value is &quot;config/.telemetria.config.json&quot;.:events - The application-specific events.See :telemetry.event_prefix/0 and :telemetry.event_name/0. The default value is [].:handler - Event handler for this application’s telemetry events. Arity must be 4. The default value is {Telemetria.Handler.Default, :handle_event}.:polling - The default value is [enabled: false, flush: 5000, poll: 5000].:enabled - Specifies whether polling should be enabled. The default value is true.:flush - Flush interval. The default value is 5000.:poll - Poll interval. The default value is 5000.","ref":"Telemetria.html","title":"Telemetria","type":"module"},{"doc":"Declares a private function with a telemetry attached, measuring execution time","ref":"Telemetria.html#defpt/2","title":"Telemetria.defpt/2","type":"macro"},{"doc":"Declares a function with a telemetry attached, measuring execution time","ref":"Telemetria.html#deft/2","title":"Telemetria.deft/2","type":"macro"},{"doc":"Attaches telemetry to anonymous function (per clause,) or to expression(s)","ref":"Telemetria.html#t/2","title":"Telemetria.t/2","type":"macro"},{"doc":"JSON formatter that is aware of Telemetria metadata.This code is gracefully stolen from internal Kantox Observability library.","ref":"Telemetria.Formatter.html","title":"Telemetria.Formatter","type":"module"},{"doc":"Formats a log entry.","ref":"Telemetria.Formatter.html#format/4","title":"Telemetria.Formatter.format/4","type":"function"},{"doc":"Default handler used unless the custom one is specified in config.This handler collects event, measurements, metadata, and config, packs them into the keyword list and logs on :info log level.","ref":"Telemetria.Handler.Default.html","title":"Telemetria.Handler.Default","type":"module"},{"doc":"The behaviour to be implemented by consumers.Telemetría provides the default handler, that simply delegates to Logger.info/1.See: Telemetria.Handler.Default.","ref":"Telemetria.Handler.html","title":"Telemetria.Handler","type":"behaviour"},{"doc":"The callback that will be invoked by :telemetry","ref":"Telemetria.Handler.html#c:handle_event/4","title":"Telemetria.Handler.handle_event/4","type":"callback"},{"doc":"Collects and formats the current process info to insert to metadata","ref":"Telemetria.Handler.html#process_info/1","title":"Telemetria.Handler.process_info/1","type":"function"},{"doc":"","ref":"Telemetria.Handler.html#t:process_info/0","title":"Telemetria.Handler.process_info/0","type":"type"},{"doc":"","ref":"Telemetria.Error.html","title":"Telemetria.Error","type":"exception"},{"doc":"Telemetría    The helper application that simplifies and standardizes telemetry usage.","ref":"readme.html","title":"Telemetría","type":"extras"},{"doc":"def project do [ compilers: [:telemetria | Mix.compilers()] ] end def deps do [ {:telemetria, &quot;~&gt; 0.1&quot;} ] end","ref":"readme.html#installation","title":"Telemetría - Installation","type":"extras"},{"doc":"0.9.1 —[ENH] @telemetria process_info: true keyword parameter[ENH] @id is set to the correct otp_app[ENH] MFA is set properly for alerts[ENH] arguments and result are grouped under :call[ENH] total metadata cleanup0.9.0 —[ENH] add Telemetria.Formatter that can be used to produce JSON logs basing on metadata, natively integrated into telemetría0.8.0 —[ENH] add applications option accepting a keyword list of applications to enable telemetria for (with optional parameters)0.7.0 —[ENH] add named arguments in all calls to event’s context0.6.1 —[BUG] wrong order using telemetry with many clauses0.6.0 —[ENH] accept parameters in annotation @telemetria[MIN] better print of events added0.5.2 —[ENH] enabled: false config to purge all telemetria code at once0.5.1 —[ENH] add result of underlying call to metric[ENH] decrease an amount of garbage returned from caller context0.5.0 —[ENH] annotation @telemetria true as a synonym to deft/2[FIX] polling is off by default0.4.0 —[ENH] default polling of system / vm states for free[ENH] starting in phases ensuring proper instrumenter setup0.3.0 —[ENH] no need for any config in any environment[BUG] proper handling of guards in compiler, correct event names","ref":"readme.html#changelog","title":"Telemetría - Changelog","type":"extras"},{"doc":"","ref":"readme.html#documentation","title":"Telemetría - Documentation.","type":"extras"},{"doc":"Optional Telemetria SupportTo optionally include telemetria support to your library do the following.","ref":"optional-using.html","title":"Optional Telemetria Support","type":"extras"},{"doc":"In your mix.exs file, specify the dependency as optional: truedefp deps do ... {:telemetria, &quot;~&gt; 0.4&quot;, optional: true} ... end","ref":"optional-using.html#mix-exs","title":"Optional Telemetria Support - mix.exs","type":"extras"},{"doc":"Declare the custom module MyApp.Telemetria as shown below.defmodule MyApp.Telemetria do @moduledoc false @default_options [use: [], apply: [level: :info]] @all_options :telemetria |&gt; Application.get_env(:applications, []) |&gt; Keyword.get(:my_app, []) @options if @all_options == true, do: @default_options, else: Keyword.merge(@default_options, @all_options) @use @options != [] and match?({:module, Telemetria}, Code.ensure_compiled(Telemetria)) defmacro __using__(opts \\\\ []), do: if(@use, do: quote(do: use(Telemetria, unquote(opts))), else: :ok) @spec use? :: boolean() def use?, do: @use @spec use!(module :: module(), opts :: keyword()) :: :ok | nil def use!(module, opts \\\\ true), do: if(Rambla.Telemetria.use?(), do: Module.put_attribute(module, :telemetria, opts)) end","ref":"optional-using.html#custom-module","title":"Optional Telemetria Support - Custom Module","type":"extras"},{"doc":"In the module(s) where you want to optinally use Telemetria, add use MyApp.Telemetria. All the attributes are to be now declared withif Rambla.Telemetria.use?(), do: @telemetria(level: :info)orRambla.Telemetria.use!(__MODULE__, level: :info)That’s it. Enjoy.","ref":"optional-using.html#conditional-include","title":"Optional Telemetria Support - Conditional Include","type":"extras"}]